// Ionic Starter App
// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'ngCordova','starter.controllers','starter.services', 'starter.filters',
        'starter.directives','ionic-citydata','ionic-citypicker','ngIOS9UIWebViewPatch','mobiscroll-datetime','baiduMap'])

    .run(function ($ionicPlatform, $rootScope, $location, $timeout, $ionicHistory, $cordovaToast, $ionicLoading,
                   $ionicActionSheet,$cordovaAppVersion,$ionicPopup,$http,$window) {
        $ionicPlatform.ready(function () {
            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)
            if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard && $cordovaKeyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(true);
                $cordovaKeyboard.hideAccessoryBar(true);
            }

            if (window.StatusBar) {
                // org.apache.cordova.statusbar required
                StatusBar.styleLightContent();
                StatusBar.backgroundColorByName("red");
            }

            //获取所在城市
            getCity();
            //检测更新
            checkUpdate(function(){
                checkCurCity();
            });
        });

        // 检查更新
        function checkUpdate(callback) {
            $http.get('http://v4.21tb.com/xuemall/mobile/index/getLastVersionApp.json?type=ALL').success(function (data) {
                var mobileApp = data;
                var serverAppVersion = data.version; //从服务端获取最新版本
                //获取版本
                $cordovaAppVersion.getVersionNumber().then(function (version) {
                    //如果本地于服务端的APP版本不符合
                    if (version != serverAppVersion) {
                        var context = data.context==null ? '' : data.context;
                        showUpdateConfirm(context,function(){
                            callback();
                        });
                    }else{
                        callback();
                    }
                });

            })

        }

        // 显示是否更新对话框
        function showUpdateConfirm(message,cancelCallback) {
            var confirmPopup = $ionicPopup.confirm({
                title: '版本升级',
                template: message ==='' ? '有新版本，请及时更新！':message, //从服务端获取更新的内容
                cancelText: '取消',
                okText: '升级'
            });
            confirmPopup.then(function (res) {
                if (res) {
                    window.open('http://eln.so/dbYop000r', '_system', 'location=yes');
                } else {
                    // 取消更新
                    setTimeout(function(){
                        cancelCallback();
                    },100);

                }
            });
        }

        function checkCurCity(){
            $timeout(function(){
                if($rootScope.curCityName && $rootScope.indexCityName != $rootScope.curCityName){
                    var confirm = $ionicPopup.confirm({
                        title: '切换城市',
                        template: '您当前选择的城市为'+$rootScope.indexCityName+'，是否切换到'+$rootScope.curCityName+'？',
                        cancelText: '取消',
                        okText: '确定'
                    });
                    confirm.then(function (res) {
                        if (res) {//确定
                            $rootScope.indexCityName = $rootScope.curCityName;
                            $window.localStorage.indexCityName = $rootScope.indexCityName;
                        } else {
                            // 取消
                        }
                    });
                }
            },500)

        }

        function getCity(){
            $rootScope.indexCityName = $window.localStorage.indexCityName;
            //当前所在城市
            function myFun(result) {
                var cityName = result.name;
                $rootScope.curCityName = cityName.replace("市","");
                if(!$rootScope.indexCityName){
                    $rootScope.indexCityName = $rootScope.curCityName;
                    $window.localStorage.indexCityName = $rootScope.indexCityName;
                }
                $rootScope.cityLat = result.center.lat;
                $rootScope.cityLng = result.center.lng;


            }

            var myCity = new BMap.LocalCity();
            myCity.get(myFun);
        }

        $rootScope.$on('loading:show', function() {
            $ionicLoading.show({template: '<ion-spinner icon="ios"></ion-spinner>'})
        });

        $rootScope.$on('loading:hide', function() {
            $ionicLoading.hide();
        });

        //双击退出
        $ionicPlatform.registerBackButtonAction(function (e) {
            //判断处于哪个页面时双击退出
            if ($location.path() == '/tab/dash' || $location.path() == '/login' || $location.path() == '/tab/user') {
                if ($rootScope.backButtonPressedOnceToExit) {
                    ionic.Platform.exitApp();
                } else {
                    $rootScope.backButtonPressedOnceToExit = true;
                    $cordovaToast.showShortBottom('再按一次退出系统');
                    setTimeout(function () {
                        $rootScope.backButtonPressedOnceToExit = false;
                    }, 2000);
                }
            } else if ($ionicHistory.backView()) {
                $ionicHistory.goBack();
            } else {
                $rootScope.backButtonPressedOnceToExit = true;
                $cordovaToast.showShortBottom('再按一次退出系统');
                setTimeout(function () {
                    $rootScope.backButtonPressedOnceToExit = false;
                }, 2000);
            }
            e.preventDefault();
            return false;
        }, 101);

    })

    .config(function ($stateProvider, $urlRouterProvider, $httpProvider, $ionicConfigProvider, $provide) {

        $ionicConfigProvider.platform.ios.tabs.style('standard');
        $ionicConfigProvider.platform.ios.tabs.position('bottom');
        $ionicConfigProvider.platform.android.tabs.style('standard');
        $ionicConfigProvider.platform.android.tabs.position('bottom');

        $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
        $ionicConfigProvider.platform.android.navBar.alignTitle('center');

        $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-back');
        $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-ios-arrow-back');

        $ionicConfigProvider.platform.ios.views.transition('ios');
        $ionicConfigProvider.platform.android.views.transition('android');

        $ionicConfigProvider.platform.ios.views.swipeBackEnabled(false);

        $ionicConfigProvider.scrolling.jsScrolling(false);

        $httpProvider.interceptors.push('TokenInterceptor');
//        $ionicConfigProvider.backButton.previousTitleText(false);
        $httpProvider.interceptors.push(function($rootScope) {
            return {
                request: function(config) {
                    $rootScope.$broadcast('loading:show');
                    return config;
                },
                response: function(response) {
                    $rootScope.$broadcast('loading:hide');
                    return response;
                }
            }
        });

        $stateProvider
            // setup an abstract state for the tabs directive
            .state('tab', {
                url: '/tab',
                abstract: true,
                templateUrl: 'templates/tabs.html'
            })

            // Each tab has its own nav history stack:

            .state('tab.dash', {
                url: '/dash',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/index/tab-dash.html',
                        controller: 'DashCtrl'
                    }
                }
            })

            //购物车
            .state('tab.dashCart', {
                cache:false,
                url: '/dashCart',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/index/shopping-cart.html',
                        controller: 'CartCtrl'
                    }
                }
            })

            .state('tab.freeCart', {
                cache:false,
                url: '/freeCart',
                views: {
                    'tab-free': {
                        templateUrl: 'templates/index/shopping-cart.html',
                        controller: 'CartCtrl'
                    }
                }
            })

            .state('tab.accountCart', {
                cache:false,
                url: '/accountCart',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/index/shopping-cart.html',
                        controller: 'CartCtrl'
                    }
                }
            })

            .state('tab.courseCart', {
                cache:false,
                url: '/courseCart',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/index/shopping-cart.html',
                        controller: 'CartCtrl'
                    }
                }
            })


            .state('tab.city', {
                cache:false,
                url: '/city',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/index/switch-city.html',
                        controller: 'SwitchCityCtrl'
                    }
                }
            })

            //公告
            .state('tab.dashNotice', {
                url: '/dashNotice/:id',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/index/notice-detail.html',
                        controller: 'InstNotifyCtrl'
                    }
                }
            })
            .state('tab.accountNotice', {
                url: '/accountNotice/:id',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/index/notice-detail.html',
                        controller: 'InstNotifyCtrl'
                    }
                }
            })

            .state('tab.freeNotice', {
                url: '/freeNotice/:id',
                views: {
                    'tab-free': {
                        templateUrl: 'templates/index/notice-detail.html',
                        controller: 'InstNotifyCtrl'
                    }
                }
            })

            .state('tab.courseNotice', {
                url: '/courseNotice/:id',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/index/notice-detail.html',
                        controller: 'InstNotifyCtrl'
                    }
                }
            })

            //讲师主页
            .state('tab.dashTeacher', {
                cache:false,
                url: '/dashTeacher/:type/:id',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/index/teacher-index.html',
                        controller: 'TeacherCtrl'
                    }
                }
            })

            .state('tab.freeTeacher', {
                cache:false,
                url: '/freeTeacher/:type/:id',
                views: {
                    'tab-free': {
                        templateUrl: 'templates/index/teacher-index.html',
                        controller: 'TeacherCtrl'
                    }
                }
            })

            .state('tab.courseTeacher', {
                cache:false,
                url: '/courseTeacher/:type/:id',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/index/teacher-index.html',
                        controller: 'TeacherCtrl'
                    }
                }
            })

            .state('tab.accountTeacher', {
                cache:false,
                url: '/accountTeacher/:type/:id',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/index/teacher-index.html',
                        controller: 'TeacherCtrl'
                    }
                }
            })
            //内部讲师
            .state('tab.dashInnerTeacher', {
                cache:false,
                url: '/dashInnerTeacher/:type/:id',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/index/innerTeacher-index.html',
                        controller: 'TeacherCtrl'
                    }
                }
            })

            .state('tab.courseInnerTeacher', {
                cache:false,
                url: '/courseInnerTeacher/:type/:id',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/index/innerTeacher-index.html',
                        controller: 'TeacherCtrl'
                    }
                }
            })

            .state('tab.freeInnerTeacher', {
                cache:false,
                url: '/freeInnerTeacher/:type/:id',
                views: {
                    'tab-free': {
                        templateUrl: 'templates/index/innerTeacher-index.html',
                        controller: 'TeacherCtrl'
                    }
                }
            })

            .state('tab.accountInnerTeacher', {
                cache:false,
                url: '/accountInnerTeacher/:type/:id',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/index/innerTeacher-index.html',
                        controller: 'TeacherCtrl'
                    }
                }
            })
            .state('tab.msg', {
                cache:false,
                url: '/dashMsg',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/user/user-message.html',
                        controller: 'MyMessageCtrl'
                    }
                }

            })
            .state('tab.search', {//首页->搜索
                cache:false,
                url: '/search/:type',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/tab-search.html',
                        controller: 'TabSearchCtrl'
                    }
                }
            })

            .state('tab.courseSearch', {
                cache:false,
                url: '/courseSearch/:type',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/tab-search.html',
                        controller: 'TabSearchCtrl'
                    }
                }
            })

            //免费课程 搜索页面
            .state('tab.freeSearch', {
                cache:false,
                url: '/freeSearch/:type',
                views: {
                    'tab-free': {
                        templateUrl: 'templates/tab-search.html',
                        controller: 'TabSearchCtrl'
                    }
                }
            })

            .state('tab.list', {//在线课或者面授课或者找老师或者找机构
                cache:false,
                url: '/list/:type',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/list.html',
                        controller: 'TabSearchCtrl'
                    }
                }
            })

            .state('tab.showCourse', {//新版在线课，面授课，教辅材料
                cache: false,
                url: '/showCourse/:type',
                views: {
                    'tab-dash': {
                      templateUrl: 'templates/showCourse.html',
                      controller: 'TabShowCourseCtrl'
                    }
                }
            })

            .state('tab.showCategory', {//展示分类
                cache: false,
                url: '/showCategory/:type',
                views: {
                    'tab-dash': {
                      templateUrl: 'templates/course/showCategory.html',
                      controller: 'CoursesCtrl'
                    }
                }
            })

            .state('tab.tab-courses', {//在线看点击类别时的搜索
                cache:false,
                url: '/course/:id',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/list.html',
                        controller: 'TabSearchCtrl'
                    }
                }
            })

            .state('tab.category-courses', {
                cache:false,
                url: '/categoryCourses/:type/:id',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/list.html',
                        controller: 'TabSearchCtrl'
                    }
                }
            })

            .state('tab.search-courses', {//在线看右上角的搜索
                cache:false,
                url: '/searchCourse',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/tab-search.html',
                        controller: 'TabSearchCtrl'
                    }
                }
            })
            //课程类别
            .state('tab.courses', {
                url: '/courses',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/course/tab-courses.html',//tab-courses.html
                        controller: 'CoursesCtrl'
                    }
                }
            })

            //免费课
            .state('tab.free', {
                cache:false,
                url: '/freeCourse',
                views: {
                    'tab-free': {
                        templateUrl: 'templates/list.html',
                        controller: 'TabSearchCtrl'
                    }
                }
            })

            //积分商城
            .state('tab.credit', {
                cache:false,
                url: '/credit',
                views: {
                    'tab-credit': {
                        templateUrl: 'templates/credit/tab-credit.html',
                        controller: 'TabCreditCtrl'
                    }
                }
            })

            .state('tab.moreCredit', {
                cache:false,
                url: '/moreCredit/:type',
                views: {
                    'tab-credit': {
                        templateUrl: 'templates/credit/more-credit.html',
                        controller: 'MoreCreditCtrl'
                    }
                }
            })

            //课程详情
            .state('tab.course-detail', {
                cache:false,
                url: '/courseDetail/:type/:id',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/course/course-detail.html',
                        controller: 'CourseDetailCtrl'
                    }
                }
            })


            .state('tab.userCourseDetail', {
                cache:false,
                url: '/userCourseDetail/:type/:id',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/course/course-detail.html',
                        controller: 'CourseDetailCtrl'
                    }
                }
            })

          .state('tab.instOrderDetail', { //机构订单详情
            cache:false,
            url: '/instOrderDetail/:formId',
            views: {
              'tab-account': {
                templateUrl: 'templates/inst/inst-order-detail.html',
                controller: 'instOrderDetailCtrl'
              }
            }
          })

          .state('tab.instInvoice', { //发票信息详情
            cache:false,
            url: '/instInvoice/:id',
            views: {
              'tab-account': {
                templateUrl: 'templates/inst/inst-invoice.html',
                controller: 'instInvoiceCtrl'
              }
            }
          })

          .state('tab.instDeliverOrder', { //发货管理页面
            cache:false,
            url: '/instDeliverOrder',
            views: {
              'tab-account': {
                templateUrl: 'templates/inst/inst-deliver-order.html',
                controller: 'InstDeliverOrderCtrl'
              }
            }
          })

          .state('tab.deliver', { //发货信息填写页面
            cache:false,
            url: '/deliver/:id',
            views: {
              'tab-account': {
                templateUrl: 'templates/inst/inst-deliver.html',
                controller: 'InstDeliverCtrl'
              }
            }
          })

          .state('tab.instDeliverGift', {
              cache: false,
              url: '/instDeliverGift',
              views: {
                  'tab-account': {
                      templateUrl: 'templates/inst/inst-deliver-gift.html',
                      controller: 'InstDeliverGiftCtrl'
                  }
              }
          })

          .state('tab.instLogisticsGift', {
              cache: false,
              url: '/instLogisticsGift/:userGiftId/:buyerId',
              views: {
                  'tab-account': {
                      templateUrl: 'templates/inst/inst-logistics-gift.html',
                      controller: 'InstLogisticsGiftCtrl'
                  }
              }
          })

          .state('tab.instLogisticsGiftDetail', {
              cache: false,
              url: '/instLogisticsGiftDetail/:userGiftId',
              views: {
                  'tab-account': {
                      templateUrl: 'templates/inst/inst-logistics-gift-detail.html',
                      controller: 'InstLogisticsGiftDetailCtrl'
                  }
              }
          })

          .state('tab.dashCourseDetail', {
                cache:false,
                url: '/dashCourseDetail/:type/:id',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/course/course-detail.html',
                        controller: 'CourseDetailCtrl'
                    }
                }
            })

            //课程详情
            .state('tab.freeCourseDetail', {
                cache:false,
                url: '/freeCourseDetail/:type/:id',
                views: {
                    'tab-free': {
                        templateUrl: 'templates/course/course-detail.html',
                        controller: 'CourseDetailCtrl'
                    }
                }
            })

            //评论课程
            .state('tab.accountUComment', {
                url: '/accountUComment?id&certId&type',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/course/course-comment.html',
                        controller: 'CourseCommentCtrl'
                    }
                }
            })

            .state('tab.dashUComment', {
                url: '/dashUComment?id&certId&type',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/course/course-comment.html',
                        controller: 'CourseCommentCtrl'
                    }
                }
            })

            .state('tab.courseUComment', {
                url: '/courseUComment?id&certId&type',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/course/course-comment.html',
                        controller: 'CourseCommentCtrl'
                    }
                }
            })

            .state('tab.freeUComment', {
                url: '/freeUComment?id&certId&type',
                views: {
                    'tab-free': {
                        templateUrl: 'templates/course/course-comment.html',
                        controller: 'CourseCommentCtrl'
                    }
                }
            })

            .state('tab.giftComment', {
                url: '/giftComment/:goodsId/:certId',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/course/gift-comment.html',
                        controller: 'GiftCommentCtrl'
                    }
                }
            })

            .state('tab.user', {
                cache:false,
                url: '/user',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/tab-user.html',
                        controller: 'UserIndexCtrl'
                    }
                }
            })

            //机构
            .state('tab.instIndex', {
                cache:false,
                url: '/inst/:id',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/tab-inst.html',
                        controller: 'InstIndexCtrl'
                    }
                }
            })

            .state('tab.order', {
                cache:false,
                url: '/order',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-order.html',
                        controller: 'UserOrderCtrl'
                    }
                }
            })
          .state('tab.instOrder', { //机构订单
            cache:false,
            url: '/instOrder',
            views: {
              'tab-account': {
                templateUrl: 'templates/inst/inst-order.html',
                controller: 'InstOrderCtrl'
              }
            }
          })
          .state('tab.instRefund', { //机构退款管理
            cache:false,
            url: '/instRefund',
            views: {
              'tab-account': {
                templateUrl: 'templates/inst/inst-refund.html',
                controller: 'InstRefundCtrl'
              }
            }
          })
          .state('tab.auditRefund', { //机构审核退款
            cache:false,
            url: '/auditRefund/:id',
            views: {
              'tab-account': {
                templateUrl: 'templates/inst/audit-refund.html',
                controller: 'auditRefundCtrl'
              }
            }
          })
          .state('tab.userRefundDetail', { //机构审核退款
            cache:false,
            url: '/userRefundDetail/:id',
            views: {
              'tab-account': {
                templateUrl: 'templates/user/user-refund-detail.html',
                controller: 'userRefundDetailCtrl'
              }
            }
          })

          .state('tab.auditRefundSelect', { //机构审核退款选项
            cache: false,
            url: '/auditRefundSelect/:id',
            views: {
              'tab-account': {
                templateUrl: 'templates/inst/audit-refund-select.html',
                controller: 'AuditRefundSelectCtrl'
              }
            }
          })

          .state('tab.sendNews', { //机构审核退款给买家发消息
            cache:false,
            url: '/sendNews',
            views: {
              'tab-account': {
                templateUrl: 'templates/inst/send-news.html',
                controller: 'sendNewsCtrl'
              }
            }
          })
          .state('tab.refundStatus', { //机构审核退款给买家发消息
            cache:false,
            url: '/refundStatus/:id/:type',
            views: {
              'tab-account': {
                templateUrl: 'templates/inst/refund-status.html',
                controller: 'refundStatusCtrl'
              }
            }
          })
          .state('tab.instComment', { //机构评论管理
            cache:false,
            url: '/instComment',
            views: {
              'tab-account': {
                templateUrl: 'templates/inst/inst-comment.html',
                controller: 'InstCommentCtrl'
              }
            }
          })
          .state('tab.instCommentDetail', { //机构评论管理
            cache: false,
            url: '/instCommentDetail/:id/:goodsName',
            views: {
              'tab-account': {
                templateUrl: 'templates/inst/inst-comment-detail.html',
                controller: 'InstCommentDetailCtrl'
              }
            }
          })
            .state('tab.dashOrder', {
                url: '/dashOrder/:type',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/user/user-order.html',
                        controller: 'UserOrderCtrl'
                    }
                }
            })
            .state('tab.courseOrder', { //??
                url: '/courseOrder/:type',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/user/user-order.html',
                        controller: 'UserOrderCtrl'
                    }
                }
            })
            .state('tab.accountOrder', {  //??
                url: '/accountOrder/:type',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-order.html',
                        controller: 'UserOrderCtrl'
                    }
                }
            })

            .state('tab.freeOrder', {  //??
                url: '/freeOrder/:type',
                views: {
                    'tab-free': {
                        templateUrl: 'templates/user/user-order.html',
                        controller: 'UserOrderCtrl'
                    }
                }
            })

            .state('tab.collect', {
                cache:false,
                url: '/collect',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-collect.html',
                        controller: 'MyFavCourseCtrl'
                    }
                }

            })
            .state('tab.follow', {
                cache: false,
                url: '/follow',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-follow.html',
                        controller: 'MyFavTeacherCtrl'
                    }
                }
            })

            .state('tab.coupon', {
                cache: false,
                url: '/coupon',
                views: {
                  'tab-account': {
                    templateUrl: 'templates/user/user-coupon.html',
                    controller: 'MyCouponCtrl'
                  }
                }
            })

            .state('tab.gift', {
                cache: false,
                url: '/gift',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-gift.html',
                        controller: 'MyGiftCtrl'
                    }
                }
            })

            .state('tab.viewLogistics', {
                cache: false,
                url: '/viewLogistics/:shipperCode/:logisticCode',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/view-logistics.html',
                        controller: 'ViewLogisticsCtrl'
                    }
                }
            })

            .state('tab.message', {
                cache:false,
                url: '/accountMsg',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-message.html',
                        controller: 'MyMessageCtrl'
                    }
                }

            })
            .state('tab.uCourse', {
                cache:false,
                url: '/uCourse',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-uCourse.html',
                        controller: 'MyCourseCtrl'
                    }
                }
            })
            .state('tab.dashUCourse', {
                url: '/dashUCourse',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/user/user-uCourse.html',
                        controller: 'MyCourseCtrl'
                    }
                }
            })
            .state('tab.courseUCourse', {
                url: '/courseUCourse',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/user/user-uCourse.html',
                        controller: 'MyCourseCtrl'
                    }
                }
            })
            .state('tab.accountUCourse', {
                url: '/accountUCourse',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-uCourse.html',
                        controller: 'MyCourseCtrl'
                    }
                }
            })

            .state('tab.freeUCourse', {
                url: '/freeUCourse',
                views: {
                    'tab-free': {
                        templateUrl: 'templates/user/user-uCourse.html',
                        controller: 'MyCourseCtrl'
                    }
                }
            })
            .state('tab.accountUCourseDetail', {
                cache: false,
                url: '/accountUCourseDetail/:id/:courseType',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-uCourseDetail.html',
                        controller: 'MyCourseDetailCtrl'
                    }
                }
            })
            .state('tab.dashUCourseDetail', {
                cache: false,
                url: '/dashUCourseDetail/:id/:courseType',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/user/user-uCourseDetail.html',
                        controller: 'MyCourseDetailCtrl'
                    }
                }
            })
            .state('tab.courseUCourseDetail', {
                cache: false,
                url: '/courseUCourseDetail/:id/:courseType',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/user/user-uCourseDetail.html',
                        controller: 'MyCourseDetailCtrl'
                    }
                }
            })

            .state('tab.freeUCourseDetail', {
                cache: false,
                url: '/freeUCourseDetail/:id/:courseType',
                views: {
                    'tab-free': {
                        templateUrl: 'templates/user/user-uCourseDetail.html',
                        controller: 'MyCourseDetailCtrl'
                    }
                }
            })
            .state('tab.info', {
                cache:false,
                url: '/info',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-info.html',
                        controller: 'UserInfoCtrl'
                    }
                }
            })

            //支付页面
            .state('tab.accountPayment', {
                cache:false,
                url: '/accountPayment/:type/:id',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-payment.html',
                        controller: 'PaymentCtrl'
                    }
                }
            })
            .state('tab.dashPayment', {
                cache:false,
                url: '/dashPayment/:type/:id',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/user/user-payment.html',
                        controller: 'PaymentCtrl'
                    }
                }
            })
            .state('tab.coursePayment', {
                cache:false,
                url: '/coursePayment/:type/:id',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/user/user-payment.html',
                        controller: 'PaymentCtrl'
                    }
                }
            })
            .state('tab.freePayment', {
                cache:false,
                url: '/freePayment/:type/:id',
                views: {
                    'tab-free': {
                        templateUrl: 'templates/user/user-payment.html',
                        controller: 'PaymentCtrl'
                    }
                }
            })
            .state('tab.orderPayment', {
                cache:false,
                url: '/orderPayment/:type/:id',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-payment.html',
                        controller: 'PaymentCtrl'
                    }
                }
            })
            .state('tab.dashOrderAddress', {
                cache: false,
                url: '/dashOrderAddress',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/user/order-address.html',
                        controller: 'OrderAddressCtrl'
                    }
                }
            })
            .state('tab.accountOrderAddress', {
                cache: false,
                url: '/accountOrderAddress',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/order-address.html',
                        controller: 'OrderAddressCtrl'
                    }
                }
            })
            .state('tab.dashOrderInvoice', {
                cache: false,
                url: '/dashOrderInvoice/:hasMaterials/:instIdAndHasMaterials',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/user/order-invoice.html',
                        controller: 'OrderInvoiceCtrl'
                    }
                }
            })
            .state('tab.accountOrderInvoice', {
                cache: false,
                url: '/accountOrderInvoice/:hasMaterials/:instIdAndHasMaterials',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/order-invoice.html',
                        controller: 'OrderInvoiceCtrl'
                    }
                }
            })
            .state('tab.dashOrderInvoiceType', {
                cache: false,
                url: '/dashOrderInvoiceType/:instIds',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/user/order-invoice-type.html',
                        controller: 'OrderInvoiceTypeCtrl'
                    }
                }
            })
            .state('tab.accountOrderInvoiceType', {
                cache: false,
                url: '/accountOrderInvoiceType/:instIds',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/order-invoice-type.html',
                        controller: 'OrderInvoiceTypeCtrl'
                    }
                }
            })
            .state('tab.dashOrderInvoiceTitle', {
                cache: false,
                url: '/dashOrderInvoiceTitle',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/user/order-invoice-title.html',
                        controller: 'OrderInvoiceTitleCtrl'
                    }
                }
            })
            .state('tab.accountOrderInvoiceTitle', {
                cache: false,
                url: '/accountOrderInvoiceTitle',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/order-invoice-title.html',
                        controller: 'OrderInvoiceTitleCtrl'
                    }
                }
            })
            .state('tab.dashOrderInvoiceContentType', {
                cache: false,
                url: '/dashOrderInvoiceContentType/:instIds',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/user/order-invoice-content-type.html',
                        controller: 'OrderInvoiceContentTypeCtrl'
                    }
                }
            })
            .state('tab.accountOrderInvoiceContentType', {
                cache: false,
                url: '/accountOrderInvoiceContentType/:instIds',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/order-invoice-content-type.html',
                        controller: 'OrderInvoiceContentTypeCtrl'
                    }
                }
            })
            .state('tab.dashOrderInvoiceDeliveryType', {
                cache: false,
                url: '/dashOrderInvoiceDeliveryType',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/user/order-invoice-delivery.html',
                        controller: 'OrderInvoiceDeliveryTypeCtrl'
                    }
                }
            })
            .state('tab.accountOrderInvoiceDeliveryType', {
                cache: false,
                url: '/accountOrderInvoiceDeliveryType',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/order-invoice-delivery.html',
                        controller: 'OrderInvoiceDeliveryTypeCtrl'
                    }
                }
            })
            .state('tab.dashOrderInvoiceAddress', {
                cache: false,
                url: '/dashOrderInvoiceAddress',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/user/order-invoice-address.html',
                        controller: 'OrderInvoiceAddressCtrl'
                    }
                }
            })
            .state('tab.accountOrderInvoiceAddress', {
                cache: false,
                url: '/accountOrderInvoiceAddress',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/order-invoice-address.html',
                        controller: 'OrderInvoiceAddressCtrl'
                    }
                }
            })
            .state('tab.dashOrderInvoiceFile', {
                cache: false,
                url: '/dashOrderInvoiceFile',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/user/order-invoice-file.html',
                        controller: 'OrderInvoiceFileCtrl'
                    }
                }
            })
            .state('tab.accountOrderInvoiceFile', {
                cache: false,
                url: '/accountOrderInvoiceFile',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/order-invoice-file.html',
                        controller: 'OrderInvoiceFileCtrl'
                    }
                }
            })
            .state('tab.logisticsDetail', {
              cache: false,
              url: '/logisticsDetail/:id',
              views: {
                'tab-account': {
                  templateUrl: 'templates/logistics-detail.html',
                  controller: 'LogisticsDetailCtrl'
                }
              }
            })
            .state('tab.accountOrderDetail', {
                cache: false,
                url: '/accountOrderDetail/:id',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-orderDetail.html',
                        controller: 'OrderDetailCtrl'
                    }
                }
            })
            .state('tab.courseOrderDetail', {
                cache: false,
                url: '/courseOrderDetail/:id',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/user/user-orderDetail.html',
                        controller: 'OrderDetailCtrl'
                    }
                }
            })
            .state('tab.dashOrderDetail', {
                cache: false,
                url: '/dashOrderDetail/:id',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/user/user-orderDetail.html',
                        controller: 'OrderDetailCtrl'
                    }
                }
            })
            .state('tab.userOrderDetail', {
                cache: false,
                url: '/userOrderDetail/:type/:id',
                views: {
                    'tab-account': {
                      templateUrl: 'templates/user/user-orderDetail.html',
                      controller: 'OrderDetailCtrl'
                    }
                }
            })
            .state('tab.userApplyRefund', {
                url: '/userApplyRefund/:orderFormId/:orderItemId',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-applyRefund.html',
                        controller: 'UserApplyRefundCtrl'
                    }
                }
            })
            .state('tab.userRefundFile', {
                url: '/userRefundFile',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-refund-file.html',
                        controller: 'UserRefundFileCtrl'
                    }
                }
            })
            .state('tab.userDeliver', {
                url: '/userDeliver/:refundId',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-deliver.html',
                        controller: 'UserDeliverCtrl'
                    }
                }
            })
            .state('tab.accountUSearch', {
                url: '/accountUSearch/:type',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-search.html',
                        controller: 'userSearchCtrl'
                    }
                }
            })

            .state('tab.dashUSearch', {
                url: '/dashUSearch/:type',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/user/user-search.html',
                        controller: 'userSearchCtrl'
                    }
                }
            })

            .state('tab.courseUSearch', {
                url: '/courseUSearch/:type',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/user/user-search.html',
                        controller: 'userSearchCtrl'
                    }
                }
            })

            .state('tab.freeUSearch', {
                url: '/freeUSearch/:type',
                views: {
                    'tab-free': {
                        templateUrl: 'templates/user/user-search.html',
                        controller: 'userSearchCtrl'
                    }
                }
            })
            .state('tab.interest', {
                url: '/interest',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/interest.html',
                        controller: 'UserInterestCtrl'
                    }
                }
            })

            .state('tab.dashInst', { //机构主页
                url: '/dashInst/:type/:id',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/index/inst-index.html',
                        controller: 'InstCtrl'
                    }
                }
            })

            .state('tab.freeInst', { //机构主页
                url: '/freeInst/:type/:id',
                views: {
                    'tab-free': {
                        templateUrl: 'templates/index/inst-index.html',
                        controller: 'InstCtrl'
                    }
                }
            })

            .state('tab.courseInst', { //机构主页
                url: '/courseInst/:type/:id',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/index/inst-index.html',
                        controller: 'InstCtrl'
                    }
                }
            })

            .state('tab.u-inst', { //机构主页
                url: '/accountInst/:type/:id',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/index/inst-index.html',
                        controller: 'InstCtrl'
                    }
                }
            })

            //机构课程列表页
            .state('tab.dashInstCourses', {
                url: '/dashInstCourses/:id/:name',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/index/inst-list.html',
                        controller: 'InstCourseCtrl'
                    }
                }
            })
            .state('tab.accountInstCourses', {
                url: '/accountInstCourses/:id/:name',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/index/inst-list.html',
                        controller: 'InstCourseCtrl'
                    }
                }
            })

            .state('tab.freeInstCourses', {
                url: '/freeInstCourses/:id/:name',
                views: {
                    'tab-free': {
                        templateUrl: 'templates/index/inst-list.html',
                        controller: 'InstCourseCtrl'
                    }
                }
            })

            .state('tab.courseInstCourses', {
                url: '/courseInstCourses/:id/:name',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/index/inst-list.html',
                        controller: 'InstCourseCtrl'
                    }
                }
            })

            //机构地图
            .state('tab.dashMap', {
                cache:false,
                url: '/dashMap',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/index/inst-map.html',
                        controller: 'InstMapCtrl'
                    }
                }
            })
            .state('tab.accountMap', {
                cache:false,
                url: '/accountMap',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/index/inst-map.html',
                        controller: 'InstMapCtrl'
                    }
                }
            })

            .state('tab.freeMap', {
                cache:false,
                url: '/freeMap',
                views: {
                    'tab-free': {
                        templateUrl: 'templates/index/inst-map.html',
                        controller: 'InstMapCtrl'
                    }
                }
            })
            .state('tab.courseMap', {
                cache:false,
                url: '/courseMap',
                views: {
                    'tab-courses': {
                        templateUrl: 'templates/index/inst-map.html',
                        controller: 'InstMapCtrl'
                    }
                }
            })

            .state('tab.mapSearch', { //从地图中查找机构
                cache:false,
                url: '/mapSearch/:city',
                views: {
                    'tab-dash': {
                        templateUrl: 'templates/index/inst-mapSearch.html',
                        controller: 'TabSearchCtrl'
                    }
                }
            })
            .state('about', {
                url: '/about',
                templateUrl: 'about.html'
            })

            .state('login', {
                cache:false,
                url: '/login',
                templateUrl: 'templates/login.html'
            })

            .state('register', {
                url: '/register',
                templateUrl: 'templates/register.html',
                controller: 'RegisterCtrl'
            })

            .state('agreement', {
                url: '/agreement',
                templateUrl: 'templates/agreement.html',
                controller: 'AgreementCtrl'
            })

            .state('findPass', {
                url: '/findPass',
                templateUrl: 'templates/user/find-password1.html',
                controller: 'FindPassOneCtrl'
            })

            .state('findPassTwo', {
                cache:false,
                url: '/findPassTwo/:loginName',
                templateUrl: 'templates/user/find-password2.html',
                controller: 'FindPassCtrl'
            })

            .state('findPassThreeTomobile', {
                cache:false,
                url: '/findPassThreeTomobile/:loginName',
                templateUrl: 'templates/user/find-password3.html',
                controller: 'FindPassCtrl'
            })

            .state('findPassThreeToemail', {
                cache:false,
                url: '/findPassThreeToemail/:loginName',
                templateUrl: 'templates/user/find-password4.html',
                controller: 'FindPassCtrl'
            })

            .state('resetPassword', {
                url: '/resetPassword/:loginName',
                templateUrl: 'templates/user/find-password5.html',
                controller: 'FindPassCtrl'
            })

            .state('view-v4course', { //看4.0平台的课程
                cache : false,
                url: '/viewV4course/:courseItemId',
                templateUrl: 'templates/view-v4course.html',
                controller: 'ViewCourseCtrl'
            })

            .state('viewFreeV4Course', { //免费观看4.0平台的课程
                cache : false,
                url: '/viewFreeV4Course/:goodsItemId/:courseItemId',
                templateUrl: 'templates/view-v4course.html',
                controller: 'ViewFreeV4CourseCtrl'
            })

            .state('take-phone', { //展示照片
                url: '/photos',
                templateUrl: 'templates/photos.html',
                controller:'CameraController'
            })
            .state('tab.address', { //我的地址
                cache:false,
                url: '/address',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-address.html',
                        controller: 'UserAddressCtrl'
                    }
                }
            })
            .state('tab.updateAddress', { //新增编辑地址
                cache:false,
                url: '/updateAddress/:id',
                views: {
                    'tab-account': {
                        templateUrl: 'templates/user/user-updateAddress.html',
                        controller: 'UpdateAddressCtrl'
                    }
                }
            })
        ;

        // if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/tab/dash');

    });
