angular.module('starter.directives', ['ionic'])
    .directive('ngEnter', function() {
        return function(scope, element, attrs) {
            element.bind("keydown keypress", function(event) {
                if(event.which === 13) {
                    scope.$apply(function(){
                        scope.$eval(attrs.ngEnter);
                    });

                    event.preventDefault();
                }
            });
        };
    })

    .directive('autoFocus', ['$log','$timeout', function($log, $timeout) {
        return {
            restrict: 'A',
            scope: {
              autoFocus: '='
            },
            link: function (scope, element) {
                scope.$watch('autoFocus', function (newValue) {
                    if (newValue) {
                        $timeout(function () {
                            element[0].focus();
                        })
                    }
                });

                element.on('blur', function () {
                    scope.$apply(function () {
                        scope.autoFocus = false;
                    })
                })
            }
        }
    }])
;
