/**
 * @Yohann
 */


angular.module('starter.filters', [])

    .filter('size', function () {
        return function (input) {
            return typeof input == 'object' ? input.length : 0;
        }
    })

    .filter('instType', function () {
        return function (input) {
            if (input === 'INST')
                return '机构';
            else if (input === 'TEACHER')
                return '讲师';
            else
                return '学员';
        }
    })

    .filter('accountPayType', function () {
        return function (input) {
            if (input === 'ALIPAY')
                return '支付宝';
            else if (input === 'BANK')
                return '银行卡';
            else
                return '未知';
        }
    })

    .filter('userStatus', function () {
        return function (input) {
            if (input === 'ENABLED')
                return '启用';
            else if (input === 'WAITING')
                return '待完善';
            else if (input === 'DISABLED')
                return '禁用';
        }
    })

    .filter('instStatus', function () {
        return function (input) {
            if (input === 'APPLY')
                return '待审核';
            else if (input === 'ENABLED')
                return '启用';
            else if (input === 'DISABLED')
                return '禁用';
            else if (input === 'REJECT')
                return '已拒绝';
            else
                return '未知';
        }
    })

    .filter('sex', function () {
        return function (input) {
            if (input === 'SECRET')
                return '保密';
            else if (input === 'MALE')
                return '男';
            else if (input === 'FEMALE')
                return '女';
            else
                return '未知';
        }
    })

    .filter('courseType', function () {
        return function (input) {
            if (input === 'INNER_COURSE')
                return '内训课';
            else if (input === 'ONLINE_COURSE')
                return '在线课';
            else if (input === 'OPEN_COURSE')
                return '面授课';
            else if (input === 'O2O_COURSE')
                return '课程项目';
            else if (input === 'TEACH_MATERIALS')
                return '教辅材料';
            else
                return '未知';
        }
    })

    .filter('goodsStatus', function () {
        return function (input) {
            if (input === 'ON_SALE')
                return '已上架';
            else if (input === 'DELETE')
                return '删除';
            else if (input === 'STOP_SALE' || input === 'FORBID_SALE' || input === 'AUTO_STOP_SALE')
                return '已下架';
        }
    })

    .filter('sensitiveWordStatus', function () {
        return function (input) {
            if (input === 'DRAFT')
                return '草稿';
            else if (input === 'ENABLED')
                return '启用';
            else if (input === 'DISABLED')
                return '停用';
            else
                return '未知';
        }
    })

    .filter('resourceType', function () {
        return function (layouts, resourceType, page) {
            var arrays = [];
            if (resourceType == 'COURSE') {
                angular.forEach(layouts, function (v) {
                    if (v.value != 10) {
                        arrays.push(v);
                    }
                });
                return arrays;
            } else if (resourceType == 'TEACHER' && page == 'INDEX') {
                angular.forEach(layouts, function (v) {
                    if (v.value == 10) {
                        arrays.push(v);
                    }
                });
                return arrays;
            }

            return layouts;
        }


    })


    .filter('orderStatus', function () {
        return function (input) {
            if (input === 'WAITING_PAY' || input === 'PAYING')
                return '待付款';
            else if (input === 'SUCCESS')
                return '已完成';
            else if (input === 'WAITING_DELIVER')
                return '待发货';
            else if (input === 'DELIVER')
                return '已发货';
            else if (input === 'CANCELED')
                return '已关闭';
            else if (input === 'REFUND')
                return '已付款（有退款）';
            else
                return '未知';
        }
    })

    .filter('price', function () {
        return function (input) {
            if (input == '￥0.00') {
                return '免费';
            } else {
                return input;
            }
        }
    })


    .filter('userCourseType', function () {
        return function (input) {
            if (input === 'SELF')
                return '自购买';
            else if (input === 'OTHER')
                return '被分配';
            else
                return '未知';
        }
    })

    .filter('anonymousMobile', function () {
        return function (mobile) {
            if (!!mobile)
                return mobile.substring(0, 3) + "****" + mobile.substring(mobile.length - 4, mobile.length);
            else
                return mobile;
        }
    })

    .filter('anonymousEmail', function () {
        return function (email) {
            if (!! email)
                return email.substring(0, 4) + "****" + email.substring(email.indexOf('@'), email.length);
            else
               return email;
        }
    })
    //过滤html
    .filter('trustHtml', function ($sce) {
        return function (input) {
            if(input!= undefined && input.length > 0 && input.lastIndexOf('</a>') !=-1){
                input = input.replace(/http:\/\/[\w\-_]+(\.[\w\-_]+)+([\w\-\.,@?^=%&amp;:/~\+#]*[\w\-\@?^=%&amp;/~\+#])?/g,'javascript:void(0)');
                var location = input.indexOf('<a');
                input = input.substr(0, location + 2) + " ng-click='linkPrompt()' " + input.substr(location + 2);
            }
            if(input!= undefined && input.length > 0){
              var str = input.replace(/<\/?.+?>/g,"").replace(/&nbsp;/g,"");//dds为得到后的内容
              if(str.trim() == ""){
                return "(无)";
              }else{
                return $sce.trustAsHtml(input);
              }
            }
        }
    })

    .filter('dateUtil', function () {
        return function (date) {
            var arrays = date.split(' ');
            if(arrays[0] && arrays[1]){
                var datas = arrays[0].split('-');
                var time = arrays[1].split(':');
                var year = datas[0];
                var month = datas[1];
                var day = datas[2];

                var now = new Date();
                if (year == now.getFullYear() && month == now.getMonth()+1 && day == now.getDate()) {
                    return '今天 ' + time[0] + ':' + time[1];
                }

                return year + '-' + month + '-' + day;
            }

            return date;
        }
    })

    .filter('courseNumber',function(){
        return function (input) {
            if(input == null) {
                return 0;
            } else {
                return input;
            }
        }
    })

    .filter('distance', function () {
        return function (input) {
            if(!input){
               return "";
            }else if(input<100){
                return "<100m";
            }else if(input<1000){
                return input +"m";
            }else {
                return (input/1000).toFixed(1)+"km";
            }
        }
    })

    .filter('districtFilter',function(){
        return function (input) {
            if(input == "CITY") {
                return '';
            } else {
                return input;
            }
        }
    })

    .filter('nothingToNull',function(){
        return function (input) {
            if(input == "无") {
                return '';
            } else {
                return input;
            }
        }
    })

    .filter('nullToNothing',function(){
        return function (input) {
            if(input === "" || input.length == 0) {
                return '无';
            } else {
                return input;
            }
        }
    })

    .filter('dateFilter',function(){
        return function (input) {
            if(input == null){
                return "";
            } else if(input.length > 10) {
                return input.substr(0,10);
            } else {
                return input;
            }
        }
    })

    .filter('orderDateFilter',function(){
        return function (input) {
            if(input == null){
                return "";
            } else if(input.length > 10) {
                return input.substr(5,11);
            } else {
                return input;
            }
        }
    })
    .filter('dateTimeFilter',function(){
        return function (input) {
            if(input == null){
                return "";
            } else if(input.length > 16) {
                return input.substr(0,16);
            } else {
                return input;
            }
        }
    })

    .filter('dateMMddFilter',function(){
        return function (input) {
            if(input == null){
                return "";
            } else if(input.length > 16) {
                return input.substr(5,5);
            } else {
                return input;
            }
        }
    })

    /*优先展示当前课程 所选城市地址；*/
    .filter('cityFilter',function($rootScope){
        return function (input) {
          if (input == null) {
            return '';
          }
            var cityStr = '';
            angular.forEach(input,function(v,k){
              if (v == null) {
                cityStr +='';
              } else if (v.indexOf($rootScope.indexCityName) >-1) {
                    cityStr = v+' '+cityStr;
                }else{
                    cityStr +=' '+v;
                }
            })

            return cityStr;
        }
    })

    /**
     * 课程详情页面 中面授课 计划 按照 首页所在城市 优先排在最前面
     */
    .filter('goodsItemCityFilter',function($rootScope){
        return function(input){
            var goodsItemList =[];
            var arr =[];
            var expiredGoodsItems =[];
            var indexCityName = $rootScope.indexCityName;
            angular.forEach(input,function(v,k){
                if ((v.province && v.city) && (v.province.indexOf(indexCityName) != -1 || v.city.indexOf(indexCityName) != -1) && !(v.hasExpired || v.saleCount == v.totalCount)) {
                    arr.push(v);
                } else if (v.hasExpired || v.saleCount == v.totalCount) {
                    expiredGoodsItems.push(v);
                } else {
                    goodsItemList.push(v);
                }
            });

            return arr.concat(goodsItemList, expiredGoodsItems);
        }
    })

    .filter('certNumberFilter',function(){
        return function(input){
            if(!input || input.length == 0){
                return "已失效";
            }else{
                return input;
            }
        }
    })

    .filter('refundStatus', function () {
        return function (input) {
            if (input === 'APPLY')
                return '等待商家审核';
            else if (input === 'SUCCESS')
                return '等待支付退款';
            else if (input === 'FAILED')
                return '退款失败，商家拒绝申请';
            else if (input === 'DONE')
                return '退款成功';
            else
                return '';
        }
    })

    .filter('couponPrice', function () {
        return function (input) {
            if (input == null)
                return '';
            else if (input > 0 && input <= 5)
                return 'five-coupon';
            else if (input > 5 && input <= 50)
               return 'fifty-coupon';
            else if (input > 50 && input <= 100)
                return 'one-hundred-coupon';
            else if (input > 100 && input <= 500)
                return 'five-hundred-coupon';
            else if (input > 500 && input <= 1000)
                return 'one-thousand-coupon';
            else if (input > 1000 && input <= 5000)
                return 'five-thousand-coupon';
            else if (input > 5000)
              return 'more-coupon';
            else
                return '';
        }
    })

    .filter('dateFormatUtil', function () {
        return function (date) {
            var arrays = date.split(' ');
            if(arrays[0] && arrays[1]){
                var datas = arrays[0].split('-');
                var time = arrays[1].split(':');
                var year = datas[0];
                var month = datas[1];
                var day = datas[2];
                var hour = time[0];
                var min = time[1];

                var now = new Date();
                return year + '.' + month + '.' + day + ' ' + hour + ':' + min;
            }

            return date;
        }
    })

    .filter('couponScope', function () {
        return function (input) {
            if (input == null)
                return '';
            else if (input == 'ALL')
                return '适用所有商品';
            else if (input == "GOODS")
                return '适用部分商品';
            else
                return '';
        }
    })

    .filter('goodsName', function () {
        return function (input) {
            if (input == null)
                return '';
            var flag = false;
            for (var i = 0; i < input.length; i++) {
                if (input.charCodeAt(i) > 255)
                    flag = true;
            }
            if (input.length <= 5)
                return input;
            else if (input.length > 5 && flag)
                return input.substring(0, 5) + "...";
            else if (input.length > 9 && !flag)
                return input.substring(0, 9) + "...";
            else
                return input;
        }
    })

    .filter('logisticsCompany', function () {
        return function (input) {
            if (input == null)
                return '';
            else if (input == 'ZTO')
                return '中通快递';
            else if (input == "YTO")
                return '圆通快递';
            else if (input == "STO")
                return '申通快递';
            else if (input == "HTKY")
                return '百世快递';
            else if (input == "SF")
                return '顺丰快递';
            else if (input == "YD")
                return '韵达快递';
            else if (input == "HHTT")
                return '天天快递';
            else if (input == "EMS")
                return '邮政EMS';
            else if (input == "YZPY")
                return '邮政小包';
            else
                return input;
        }
    })

    .filter('couponType', function () {
        return function (input) {
            if (input == null)
                return '';
            else if (input == 'ALL')
                return '全部';
            else if (input == 'GOODS')
                return '部分';
        }
    })

    .filter('invoiceType', function () {
        return function (input) {
            if (input == null)
              return '';
            else if (input == 'ORDINARY')
              return '增值税普通发票';
            else if (input == 'VAT')
              return '增值税专用发票';
        }
    })

    .filter('invoiceContentType', function () {
        return function (input) {
            if (input == null)
              return '';
            else if (input == 'DETAIL')
              return '明细';
            else if (input == 'OFFICE')
              return '办公用品';
        }
    })

    .filter('invoiceStatus', function () {
        return function (input) {
            if (input == null)
                return '';
            else if (input == 'WAIT_INVOICE')
                return '待开票';
            else if (input == 'WAIT_SEND')
                return '待寄出';
            else if (input == 'HAS_SEND')
                return '已寄出';
        }
    })

    .filter('giftStatus', function () {
        return function (input) {
            if (input == null)
                return '';
            else if (input == 'UN_DELIVER')
                return '待发货';
            else if (input == 'DELIVERED')
                return '待收货';
            else if (input == 'SUCCESS')
                return '已收货';
        }
    })

    .filter('certificateStatus', function () {
        return function (input) {
            if (input == null)
                return '';
            else if (input == 'DRAFT')
                return '新增';
            else if (input == 'SHARED')
                return '已分配';
            else if (input == 'FROZEN')
                return '冻结';
            else if (input == 'ABOLISH')
                return '废弃';
            else if (input == 'USED')
                return '已用';
        }
    })

;
